libgphoto2 (libgphoto2): camlibs/template/template.c File Reference

- Main Page
- Data Structures
- Files
- Directories
- Related Pages

- File List
- Globals

# template.c File Reference

Documented source code template for a camera driver (camlib). More...

`#include "config.h"`
`#include <string.h>`
`#include <gphoto2/gphoto2-library.h>`
`#include <gphoto2/gphoto2-result.h>`

## camlib API functions
int | camera_id (CameraText *id)
int | camera_abilities (CameraAbilitiesList *list)
int | camera_init (Camera *camera, GPContext *context)
## Defines
#define | _(String) (String)
#define | N_(String) (String)

## Detailed Description

Documented source code template for a camera driver (camlib).

Author:
  Copyright © 2001 Lutz Müller <lutz@users.sourceforge.net>

  Copyright © 2005 Hans Ulrich Niedermann <gp@n-dimensional.de>

  This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

## Introduction to camera drivers (camlibs)

Every camlib must implement the following three function groups:

- Camera object member functions
- CameraFilesystem object member functions
- camlib API functions

We implement the camlib API functions last in this file because camera_init() must reference all the object member functions and by making camera_init() the last function in this file, we can avoid the need for forward declarations of the object member functions.

## Note about "static" functions and exporting symbols

The build system uses libtool to explicitly specify the list of exported symbols. Only the three functions of the camlib API (camera_init(), camera_id(), and camera_abilities()) are exported.

Therefore it doesn't matter whether you declare your other functions static or not - regardless of whether they are object member functions or internal camlib functions.

We do not define the object member functions as static in this template in order to have autogenerated documentation about them.

## Function Documentation

int camera_abilities | ( | CameraAbilitiesList * | list | ) |

Fill list with abilities of the cameras supported by this camlib.

For each camera, fill a CameraAbilities structure with data about that camera and append it to the list.

The job of this function is basically to extract data from a camlib specific database and insert it into the libgphoto2 camera database. Due to redundant data and other issues, we may decide to revise that database mechanism and replace it by something more flexible and efficient.

This is a camlib API function.

int camera_id | ( | CameraText * | id | ) |

Set library ID string.

Probably redundant and to be removed shortly, being replaced by the libtool module name defined in the build system.

This is a camlib API function.

int camera_init | ( | Camera * | camera,
|  | GPContext * | context |
| ) |  |  |

Initialize a Camera object.

Sets up all the proper object function pointers, initialize camlib internal data structures, and probably establish a connection to the camera.

This is a camlib API function.